/********************************** (C) COPYRIGHT *******************************
* File Name          : CH563.c
* Author             : WCH
* Version            : V1.1
* Date               : 2014/08/01
* Description        : CH9343 UART Գ򣨲CH9343طͣ
*                      (1)CH563CԵĲԳ
*                      (2)Examples by KEIL3_V3.40;    
*                      (3)0CH9343ͨѶ;
*                      (4)1Ϣ,115200bps;
*******************************************************************************/


/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH563SFR.H"
#include "SYSFREQ.H"

/******************************************************************************/
#define	LED_MAIN_WORK_INIT( )	{ R32_PB_DIR |= ( 1<<3 ); R32_PB_OUT |= ( 1<<3 ); }		/* ָʾ */
#define	LED_MAIN_WORK_ACT( )	( R32_PB_CLR |= ( 1<<3 ) )
#define	LED_MAIN_WORK_INACT( )	( R32_PB_OUT |= ( 1<<3 ) )
#define	LED_MAIN_WORK_TWK( )	( R32_PB_OUT ^= ( 1<<3 ) )

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }         /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                            /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                            /* LED ߵƽرLEDʾ */
#define	DEF_UART_CTS_GET( )	 ( R32_PA_PIN & ( 1<<12 ) )		/* ȡCTS״̬,ߣֹ ͣ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

 __irq void IRQ_Handler( void )
{
    while(1);
}
  
/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : Uart0_Init
* Description    : 0ʼ
* Input          : baud-ڲʣΪƵ1/8
* Output         : None
* Return         : None
*******************************************************************************/

void Uart0_Init( UINT32  baud )
{
    UINT32 x;

    x = 10 * FREQ_SYS/ 8 / baud;                                                /* 115200bps */
    x += 5;                                                                        /*  */
    x /= 10;
    R8_UART0_LCR = RB_LCR_DLAB;                                                 /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;              
    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R8_UART0_MCR = RB_MCR_OUT1;
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PU  |= RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 Ϊ */
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( void )
{
	UINT32	x, x2;
	x = 10 * FREQ_SYS * 2 / 16 / 115200;  /* 115200bps */
	x2 = x % 10;
	x /= 10;
	if ( x2 >= 5 ) x ++;  /*  */
	R8_UART1_LCR = 0x80;  /* DLABλ1 */
	R8_UART1_DIV = 1;     /* ԤƵ	 */
	R8_UART1_DLM = x>>8;
	R8_UART1_DLL = x&0xff;
	R8_UART1_LCR = 0x03;
	R8_UART1_FCR = 0xC7;
	R8_UART1_IER = RB_IER_TXD_EN;  /* TXD enable */

	R32_PB_SMT |= RXD1 | TXD1;  /* RXD0 schmitt input, TXD0 slow rate */
	R32_PB_PD &= ~ RXD1;  /* disable pulldown for RXD0, keep pullup	*/
	R32_PB_DIR |= TXD1;  /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
	R8_UART1_THR = c;                                          /*  */
	while( ( R8_UART1_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );       /* ȴݷ */
	return( c );
}

/*******************************************************************************
* Function Name  : UART0_SendByte
* Description    : 0ֽӳ
* Input          : dat -Ҫ͵
* Output         : None
* Return         : None
*******************************************************************************/

void UART0_SendByte( UINT8 dat )   
{        
    R8_UART0_THR  = dat;
    while( ( R8_UART0_LSR & RB_LSR_TX_ALL_EMP ) == 0 );                         /* ȴݷ */       
}

/*******************************************************************************
* Function Name  : UART0_SendStr
* Description    : 0ַӳ 
* Input          : *str -͵ַ
* Output         : None
* Return         : None
*******************************************************************************/

void UART0_SendStr( UINT8 *str )   
{
    while( 1 ){
        if( *str == '\0' ) break;
        UART0_SendByte( *str++ );
    }
}

/*******************************************************************************
* Function Name  : UART0_RcvByte
* Description    : 0һֽӳ  
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

UINT8 UART0_RcvByte( void )    
{
    UINT8 Rcvdat = 0;

    if( !( ( R8_UART0_LSR  ) & ( RB_LSR_OVER_ERR |RB_LSR_PAR_ERR  | RB_LSR_FRAME_ERR |  RB_LSR_BREAK_ERR  ) ) ) {
        while( ( R8_UART0_LSR & RB_LSR_DATA_RDY  ) == 0 );                      /* ȴ׼ */ 
        Rcvdat = R8_UART0_RBR;                                                  /* ӽջĴ */ 
    }
    else{
        R8_UART0_RBR;                                                           /* д */
    }
    return( Rcvdat );
}

/*******************************************************************************
* Function Name  : Seril0Send
* Description    : FIFO0Ͷֽڳ
* Input          : Data -Ҫ͵
*                  Num  -ݵĳ
* Output         : None
* Return         : None
*******************************************************************************/

void  Seril0Send( UINT8 *Data, UINT8 Num )                        
{
    do{
        while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                    /* ȴݷ */ 
        R8_UART0_THR  =*Data++;  
    }while( --Num );
}

/*******************************************************************************
* Function Name  : Seril0Rcv
* Description    : FIFO,0նֽӳ
* Input          : buf -ݻ
* Output         : None
* Return         : RcvNum -ݳ
*******************************************************************************/

UINT8  Seril0Rcv( UINT8 *buf )    
{
    UINT8 RcvNum = 0;

    if( !( ( R8_UART0_LSR  ) & ( RB_LSR_OVER_ERR |RB_LSR_PAR_ERR | RB_LSR_FRAME_ERR | RB_LSR_BREAK_ERR ))){
        while( ( R8_UART0_LSR & RB_LSR_DATA_RDY  ) == 0 );                      /* ȴ׼ */  
        do{
            *buf++ = R8_UART0_RBR;                                              /* ӽջĴ */ 
            RcvNum++;
        }while( (R8_UART0_LSR & RB_LSR_DATA_RDY) == 0x01 );
    }
    else{
        R8_UART0_RBR;
    }
    return( RcvNum );
}
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
	UINT16	i, k;
	UINT8   RecvBuf[ 6 ];
	LED_OUT_INIT( );
    LED_OUT_ACT( );       /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
	mInitSTDIO( );		/* Ϊüͨڼʾ */
	Uart0_Init( 921600 );    /*  0ʼ */ 
	printf( "CH9343 UART Test\n" );
	/* ؿ */
	R32_PA_PU |= 1<<12;							   /* (PA12) CH9343 RTS0 */ 
	R32_PA_DIR &= ~( 1<<12 );
	R32_PA_DIR |= ( 1<<8 ); 					   /* (PA8) CH9343 CTS0 */
	R32_PA_OUT |= ( 1<<8 );

    k = 0; 
    i = 0;
	printf( "Test CH9343 Uart Flow Send \n" );
	while( 1 ){
	    while( 1 ){
	    	R32_PA_CLR |= RTS0;           /* CH563RST#ߵƽֹCH9343ڷ */ 
			RecvBuf[ k++ ] = UART0_RcvByte( );
			if(k==6)                     /*  */
	        {                      
	            R32_PA_OUT |= RTS0;     /* CH563RST#ߵƽֹCH9343ڷ */ 
	            for(k=0;k<6;k++)
	            {
	                printf ("buf[%d]=%02x\n",k,RecvBuf[k]);  /* 2ӡ */
	            }
	            k=0;
	            break;         
	        }
	     }
	     i++;
	     if(i==5) break;
    }
    printf( "Over\n" );
}

/*********************************** endfile **********************************/
