package com.GPIODemo;

import android.app.Activity;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.ToggleButton;

import com.GPIODemo.R.drawable;

/*CH9343 GPIO interface exposes the following methods:
 *   ConfigPort, WritePort and ReadPort are for user to use for port operations.
 *   - ConfigPort(outMap, inMap): to configure the port as input or output, with outMap and inMap 
 *   							  are arguments for out bitmap and input bitmap.
 *   - WritePort(outData): to write the port data, with outData as argument.
 *   - ReadPort: to read port, it returns the current level on the input IOs.
 *   
 *   DestroyAccessory and ResumeAccessory methods should be called from
 *   overridden  from onResume() and onDestroy routines of main activity class.
 *   
 *   - DestoryAccessory: to be called from onDestory routine of main activity class.
 *   - ResumeAccessory: to be called from onResume routine of main activity class.
 *   
 *   
 */

public class GPIODemoActivity extends Activity {

	/* declare a CH9343 GPIO interface variable */
	public WCHGPIOInterface gpiointerface;

	/* object variables to hold layout objects for output maps */
	public CheckBox checkbox0;
	public CheckBox checkbox1;
	public CheckBox checkbox2;
	public CheckBox checkbox3;
	public CheckBox checkbox4;
	public CheckBox checkbox5;
	public CheckBox checkbox6;
	public CheckBox checkbox7;
	public CheckBox checkbox8;
	public CheckBox checkbox9;
	public CheckBox checkbox10;
	public CheckBox checkbox11;
	public CheckBox checkbox12;
	public CheckBox checkbox13;
	public CheckBox checkbox14;
	public CheckBox checkbox15;

	/* object variables to hold layout objects for input maps */
	public CheckBox checkboxin0;
	public CheckBox checkboxin1;
	public CheckBox checkboxin2;
	public CheckBox checkboxin3;
	public CheckBox checkboxin4;
	public CheckBox checkboxin5;
	public CheckBox checkboxin6;
	public CheckBox checkboxin7;
	public CheckBox checkboxin8;
	public CheckBox checkboxin9;
	public CheckBox checkboxin10;
	public CheckBox checkboxin11;
	public CheckBox checkboxin12;
	public CheckBox checkboxin13;
	public CheckBox checkboxin14;
	public CheckBox checkboxin15;

	/* variables to hold the out value */
	public ToggleButton togglebutton0;
	public ToggleButton togglebutton1;
	public ToggleButton togglebutton2;
	public ToggleButton togglebutton3;
	public ToggleButton togglebutton4;
	public ToggleButton togglebutton5;
	public ToggleButton togglebutton6;
	public ToggleButton togglebutton7;
	public ToggleButton togglebutton8;
	public ToggleButton togglebutton9;
	public ToggleButton togglebutton10;
	public ToggleButton togglebutton11;
	public ToggleButton togglebutton12;
	public ToggleButton togglebutton13;
	public ToggleButton togglebutton14;
	public ToggleButton togglebutton15;
	
	/* input data variables */
	public ImageView inputbutton0;
	public ImageView inputbutton1;
	public ImageView inputbutton2;
	public ImageView inputbutton3;
	public ImageView inputbutton4;
	public ImageView inputbutton5;
	public ImageView inputbutton6;
	public ImageView inputbutton7;
	public ImageView inputbutton8;
	public ImageView inputbutton9;
	public ImageView inputbutton10;
	public ImageView inputbutton11;
	public ImageView inputbutton12;
	public ImageView inputbutton13;
	public ImageView inputbutton14;
	public ImageView inputbutton15;

	/* button object */
	public Button configbutton;
	public Button writebutton;
	public Button readbutton;
	public Button resetbutton;

	/* text boxes for data display */
	public EditText configoutdata;
	public EditText configindata;
	public EditText writedata;
	public EditText readdata;

	/* variables */
	public int outMap; /* outmap */
	public int inMap; /* inmap */
	public int outData; /* output data */
	public int inData; /* input Data */

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		/* create objects of out checkboxes */
		checkbox0 = (CheckBox) findViewById(R.id.checkbox1);
		checkbox1 = (CheckBox) findViewById(R.id.checkbox2);
		checkbox2 = (CheckBox) findViewById(R.id.checkbox3);
		checkbox3 = (CheckBox) findViewById(R.id.checkbox4);
		checkbox4 = (CheckBox) findViewById(R.id.checkbox5);
		checkbox5 = (CheckBox) findViewById(R.id.checkbox6);
		checkbox6 = (CheckBox) findViewById(R.id.checkbox7);
		checkbox7 = (CheckBox) findViewById(R.id.checkbox8);
		checkbox8 = (CheckBox) findViewById(R.id.checkbox9);
		checkbox9 = (CheckBox) findViewById(R.id.checkbox10);
		checkbox10 = (CheckBox) findViewById(R.id.checkbox11);
		checkbox11 = (CheckBox) findViewById(R.id.checkbox12);
		checkbox12 = (CheckBox) findViewById(R.id.checkbox13);
		checkbox13 = (CheckBox) findViewById(R.id.checkbox14);
		checkbox14 = (CheckBox) findViewById(R.id.checkbox15);
		checkbox15 = (CheckBox) findViewById(R.id.checkbox16);

		/* create objects of IN checkboxes */
		checkboxin0 = (CheckBox) findViewById(R.id.checkboxin1);
		checkboxin1 = (CheckBox) findViewById(R.id.checkboxin2);
		checkboxin2 = (CheckBox) findViewById(R.id.checkboxin3);
		checkboxin3 = (CheckBox) findViewById(R.id.checkboxin4);
		checkboxin4 = (CheckBox) findViewById(R.id.checkboxin5);
		checkboxin5 = (CheckBox) findViewById(R.id.checkboxin6);
		checkboxin6 = (CheckBox) findViewById(R.id.checkboxin7);
		checkboxin7 = (CheckBox) findViewById(R.id.checkboxin8);
		checkboxin8 = (CheckBox) findViewById(R.id.checkboxin9);
		checkboxin9 = (CheckBox) findViewById(R.id.checkboxin10);
		checkboxin10 = (CheckBox) findViewById(R.id.checkboxin11);
		checkboxin11 = (CheckBox) findViewById(R.id.checkboxin12);
		checkboxin12 = (CheckBox) findViewById(R.id.checkboxin13);
		checkboxin13 = (CheckBox) findViewById(R.id.checkboxin14);
		checkboxin14 = (CheckBox) findViewById(R.id.checkboxin15);
		checkboxin15 = (CheckBox) findViewById(R.id.checkboxin16);

		/* create output data objects */
		togglebutton0 = (ToggleButton) findViewById(R.id.togglebutton1);
		togglebutton1 = (ToggleButton) findViewById(R.id.togglebutton2);
		togglebutton2 = (ToggleButton) findViewById(R.id.togglebutton3);
		togglebutton3 = (ToggleButton) findViewById(R.id.togglebutton4);
		togglebutton4 = (ToggleButton) findViewById(R.id.togglebutton5);
		togglebutton5 = (ToggleButton) findViewById(R.id.togglebutton6);
		togglebutton6 = (ToggleButton) findViewById(R.id.togglebutton7);
		togglebutton7 = (ToggleButton) findViewById(R.id.togglebutton8);
		togglebutton8 = (ToggleButton) findViewById(R.id.togglebutton9);
		togglebutton9 = (ToggleButton) findViewById(R.id.togglebutton10);
		togglebutton10 = (ToggleButton) findViewById(R.id.togglebutton11);
		togglebutton11 = (ToggleButton) findViewById(R.id.togglebutton12);
		togglebutton12 = (ToggleButton) findViewById(R.id.togglebutton13);
		togglebutton13 = (ToggleButton) findViewById(R.id.togglebutton14);
		togglebutton14 = (ToggleButton) findViewById(R.id.togglebutton15);
		togglebutton15 = (ToggleButton) findViewById(R.id.togglebutton16);

		/* image buttons to be changed on receiving the input data */
		inputbutton0 = (ImageView) findViewById(R.id.intogglebutton1);
		inputbutton1 = (ImageView) findViewById(R.id.intogglebutton2);
		inputbutton2 = (ImageView) findViewById(R.id.intogglebutton3);
		inputbutton3 = (ImageView) findViewById(R.id.intogglebutton4);
		inputbutton4 = (ImageView) findViewById(R.id.intogglebutton5);
		inputbutton5 = (ImageView) findViewById(R.id.intogglebutton6);
		inputbutton6 = (ImageView) findViewById(R.id.intogglebutton7);
		inputbutton7 = (ImageView) findViewById(R.id.intogglebutton8);
		inputbutton8 = (ImageView) findViewById(R.id.intogglebutton9);
		inputbutton9 = (ImageView) findViewById(R.id.intogglebutton10);
		inputbutton10 = (ImageView) findViewById(R.id.intogglebutton11);
		inputbutton11 = (ImageView) findViewById(R.id.intogglebutton12);
		inputbutton12 = (ImageView) findViewById(R.id.intogglebutton13);
		inputbutton13 = (ImageView) findViewById(R.id.intogglebutton14);
		inputbutton14 = (ImageView) findViewById(R.id.intogglebutton15);
		inputbutton15 = (ImageView) findViewById(R.id.intogglebutton16);

		/* text boxes for data display */
		configoutdata = (EditText) findViewById(R.id.outmapdata);
		configindata = (EditText) findViewById(R.id.inmapdata);
		writedata = (EditText) findViewById(R.id.writedata);
		readdata = (EditText) findViewById(R.id.readdata);

		/**** comamnd buttons *****/
		configbutton = (Button) findViewById(R.id.configbutton);
		readbutton = (Button) findViewById(R.id.readbutton);
		writebutton = (Button) findViewById(R.id.writebutton);
		resetbutton = (Button) findViewById(R.id.resetbutton);

		/************************ process the OUTPUT bitmap ******************************/
		checkbox0.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 0);
				/* when setting the direction, its driven to low */
				togglebutton0.setChecked(false);
				if (((CheckBox) v).isChecked() == true) { 
					outMap |= (1 << 0);
					inMap &= ~(1 << 0);
					checkboxin0.setChecked(false);

				}
				outData &= ~outMap;
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkbox1.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 1);
				/* when setting the direction, its driven to low */
				togglebutton1.setChecked(false);
				if (((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 1);
					inMap &= ~(1 << 1);
					checkboxin1.setChecked(false);

				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkbox2.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 2);
				if (((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 2);
					inMap &= ~(1 << 2);
					checkboxin2.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkbox3.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 3);
				if (((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 3);
					inMap &= ~(1 << 3);
					checkboxin3.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkbox4.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 4);
				if (((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 4);
					inMap &= ~(1 << 4);
					checkboxin4.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkbox5.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 5);
				if (((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 5);
					inMap &= ~(1 << 5);
					checkboxin5.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkbox6.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 6);
				if (((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 6);
					inMap &= ~(1 << 6);
					checkboxin6.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});
		
		checkbox7.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 7);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 7);
					inMap &= ~(1 << 7);
					checkboxin7.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
		}
				
			}
		});
		
		checkbox8.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 8);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 8);
					inMap &= ~(1 << 8);
					checkboxin8.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});
		
		checkbox9.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 9);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 9);
					inMap &= ~(1 << 9);
					checkboxin9.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});
		
		checkbox10.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 10);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 10);
					inMap &= ~(1 << 10);
					checkboxin10.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});
		
		checkbox11.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 11);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 11);
					inMap &= ~(1 << 11);
					checkboxin11.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});
		
		checkbox12.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 12);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 12);
					inMap &= ~(1 << 12);
					checkboxin12.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});
		
		checkbox13.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 13);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 13);
					inMap &= ~(1 << 13);
					checkboxin13.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});
		
		checkbox14.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 14);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 14);
					inMap &= ~(1 << 14);
					checkboxin14.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});
		
		checkbox15.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				outMap &= ~(1 << 15);
				if(((CheckBox) v).isChecked() == true) {
					outMap |= (1 << 15);
					inMap &= ~(1 << 15);
					checkboxin15.setChecked(false);
					
					configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
					configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
				}
			}
		});

		/************************ process the INPUT bitmap ******************************/
		checkboxin0.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 0);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 0);
					outMap &= ~(1 << 0);
					checkbox0.setChecked(false);
				}

				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkboxin1.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 1);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 1);
					outMap &= ~(1 << 1);
					checkbox1.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkboxin2.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 2);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 2);
					outMap &= ~(1 << 2);
					checkbox2.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkboxin3.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 3);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 3);
					outMap &= ~(1 << 3);
					checkbox3.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkboxin4.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 4);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 4);
					outMap &= ~(1 << 4);
					checkbox4.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkboxin5.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 5);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 5);
					outMap &= ~(1 << 5);
					checkbox5.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});

		checkboxin6.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 6);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 6);
					outMap &= ~(1 << 6);
					checkbox6.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

			}
		});
		
		checkboxin7.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 7);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 7);
					outMap &= ~(1 << 7);
					checkbox7.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin8.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 8);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 8);
					outMap &= ~(1 << 8);
					checkbox8.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin9.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 9);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 9);
					outMap &= ~(1 << 9);
					checkbox9.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin10.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 10);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 10);
					outMap &= ~(1 << 10);
					checkbox10.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin11.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 11);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 11);
					outMap &= ~(1 << 11);
					checkbox11.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin12.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 12);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 12);
					outMap &= ~(1 << 12);
					checkbox12.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin13.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 13);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 13);
					outMap &= ~(1 << 13);
					checkbox13.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin14.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 14);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 14);
					outMap &= ~(1 << 14);
					checkbox14.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});
		
		checkboxin15.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				/* by default clear the out map */
				inMap &= ~(1 << 15);
				if (((CheckBox) v).isChecked() == true) {
					inMap |= (1 << 15);
					outMap &= ~(1 << 15);
					checkbox15.setChecked(false);
				}
				configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
				configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));
			}
		});

		/****************************** process output data ******************************************/
		togglebutton0.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 0);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 0);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));

			}
		});

		togglebutton1.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 1);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 1);
				}

				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));

			}
		});

		togglebutton2.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 2);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 2);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));

			}
		});

		togglebutton3.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 3);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 3);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));

			}
		});

		togglebutton4.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 4);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 4);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));

			}
		});

		togglebutton5.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 5);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 5);
				}

				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));

			}
		});

		togglebutton6.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 6);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 6);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));

			}
		});
		
		togglebutton7.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 7);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 7);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton8.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 8);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 8);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton9.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 9);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 9);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton10.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 10);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 10);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton11.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 11);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 11);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton12.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 12);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 12);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton13.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 13);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 13);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton14.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 14);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 14);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});
		
		togglebutton15.setOnClickListener(new View.OnClickListener() {
			
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				outData &= ~(1 << 15);
				if (((ToggleButton) v).isChecked() == true) {
					outData |= (1 << 15);
				}
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
			}
		});

		/****************************** process button presses *********************************/
		/* user code to configure port data */
		configbutton.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				togglebutton0.setChecked(false);
				togglebutton1.setChecked(false);
				togglebutton2.setChecked(false);
				togglebutton3.setChecked(false);
				togglebutton4.setChecked(false);
				togglebutton5.setChecked(false);
				togglebutton6.setChecked(false);
				togglebutton7.setChecked(false);
				togglebutton8.setChecked(false);
				togglebutton9.setChecked(false);
				togglebutton10.setChecked(false);
				togglebutton11.setChecked(false);
				togglebutton12.setChecked(false);
				togglebutton13.setChecked(false);
				togglebutton14.setChecked(false);
				togglebutton15.setChecked(false);
				outData &= ~outMap;
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
				gpiointerface.ConfigPort(outMap, inMap);
			}
		});

		/* user code to write port */
		writebutton.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				/* send only the output mapped data */
				outData &= outMap;
				writedata.setText("0x" + Integer.toHexString(outData & 0xffff));
				gpiointerface.WritePort(outData);

			}

		});

		/* user code to read the accessory data */
		readbutton.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				inData = gpiointerface.ReadPort();
				readdata.setText("0x" + Integer.toHexString(inData & 0xffff)); 
				ProcessReadData(inData);
			}
		});

		/* user code to reset the accessory data */
		resetbutton.setOnClickListener(new View.OnClickListener() {

			// @Override
			public void onClick(View v) {
				resetCH9343();
				;
			}
		});

		/* create an object of GPIO interface class */
		gpiointerface = new WCHGPIOInterface(this);
		resetCH9343();

	}

	protected void resetCH9343() {
		gpiointerface.ResetPort();

		checkbox0.setChecked(false);
		checkbox1.setChecked(false);
		checkbox2.setChecked(false);
		checkbox3.setChecked(false);
		checkbox4.setChecked(false);
		checkbox5.setChecked(false);
		checkbox6.setChecked(false);
		checkbox7.setChecked(false);
		checkbox8.setChecked(false);
		checkbox9.setChecked(false);
		checkbox10.setChecked(false);
		checkbox11.setChecked(false);
		checkbox12.setChecked(false);
		checkbox13.setChecked(false);
		checkbox14.setChecked(false);
		checkbox15.setChecked(false);

		checkboxin0.setChecked(true);
		checkboxin1.setChecked(true);
		checkboxin2.setChecked(true);
		checkboxin3.setChecked(true);
		checkboxin4.setChecked(true);
		checkboxin5.setChecked(true);
		checkboxin6.setChecked(true);
		checkboxin7.setChecked(true);
		checkboxin8.setChecked(true);
		checkboxin9.setChecked(true);
		checkboxin10.setChecked(true);
		checkboxin11.setChecked(true);
		checkboxin12.setChecked(true);
		checkboxin13.setChecked(true);
		checkboxin14.setChecked(true);
		checkboxin15.setChecked(true);

		togglebutton0.setChecked(false);
		togglebutton1.setChecked(false);
		togglebutton2.setChecked(false);
		togglebutton3.setChecked(false);
		togglebutton4.setChecked(false);
		togglebutton5.setChecked(false);
		togglebutton6.setChecked(false);
		togglebutton7.setChecked(false);
		togglebutton8.setChecked(false);
		togglebutton9.setChecked(false);
		togglebutton10.setChecked(false);
		togglebutton11.setChecked(false);
		togglebutton12.setChecked(false);
		togglebutton13.setChecked(false);
		togglebutton14.setChecked(false);
		togglebutton15.setChecked(false);

		ProcessReadData((byte) 0);

		outMap = (int) 0x0000;
		inMap = (int) 0xffff;
		configoutdata.setText("0x" + Integer.toHexString(outMap & 0xffff));
		configindata.setText("0x" + Integer.toHexString(inMap & 0xffff));

	}

	@Override
	protected void onResume() {
		// Ideally should implement onResume() and onPause()
		// to take appropriate action when the activity looses focus
		super.onResume();
		gpiointerface.ResumeAccessory();
	}

	@Override
	protected void onPause() {
		// Ideally should implement onResume() and onPause()
		// to take appropriate action when the activity looses focus
		super.onPause();
	}

	@Override
	protected void onDestroy() {

		gpiointerface.DestroyAccessory();
		super.onDestroy();
	}

	public void ProcessReadData(int portData) {
		int cmddata;

		cmddata = portData;
		/* check if the command is write */

		/* just process input map */
		cmddata &= inMap;
		readdata.setText("0x" + Integer.toHexString(cmddata & 0xffff));
		/* read data is to update the LEDs */
		if ((cmddata & 0x0001) == 0x0001)
			inputbutton0.setImageResource(drawable.image100);
		else
			inputbutton0.setImageResource(drawable.image1);

		if ((cmddata & 0x0002) == 0x0002)
			inputbutton1.setImageResource(drawable.image100);
		else
			inputbutton1.setImageResource(drawable.image1);

		if ((cmddata & 0x0004) == 0x0004)
			inputbutton2.setImageResource(drawable.image100);
		else
			inputbutton2.setImageResource(drawable.image1);

		if ((cmddata & 0x0008) == 0x0008)
			inputbutton3.setImageResource(drawable.image100);
		else
			inputbutton3.setImageResource(drawable.image1);

		if ((cmddata & 0x0010) == 0x0010)
			inputbutton4.setImageResource(drawable.image100);
		else
			inputbutton4.setImageResource(drawable.image1);

		if ((cmddata & 0x0020) == 0x0020)
			inputbutton5.setImageResource(drawable.image100);
		else
			inputbutton5.setImageResource(drawable.image1);

		if ((cmddata & 0x0040) == 0x0040)
			inputbutton6.setImageResource(drawable.image100);
		else
			inputbutton6.setImageResource(drawable.image1);
		
		if ((cmddata & 0x0080) == 0x0080)
			inputbutton7.setImageResource(drawable.image100);
		else
			inputbutton7.setImageResource(drawable.image1);
		
		if ((cmddata & 0x0100) == 0x0100)
			inputbutton8.setImageResource(drawable.image100);
		else
			inputbutton8.setImageResource(drawable.image1);

		if ((cmddata & 0x0200) == 0x0200)
			inputbutton9.setImageResource(drawable.image100);
		else
			inputbutton9.setImageResource(drawable.image1);

		if ((cmddata & 0x0400) == 0x0400)
			inputbutton10.setImageResource(drawable.image100);
		else
			inputbutton10.setImageResource(drawable.image1);

		if ((cmddata & 0x0800) == 0x0800)
			inputbutton11.setImageResource(drawable.image100);
		else
			inputbutton11.setImageResource(drawable.image1);

		if ((cmddata & 0x1000) == 0x1000)
			inputbutton12.setImageResource(drawable.image100);
		else
			inputbutton12.setImageResource(drawable.image1);

		if ((cmddata & 0x2000) == 0x2000)
			inputbutton13.setImageResource(drawable.image100);
		else
			inputbutton13.setImageResource(drawable.image1);

		if ((cmddata & 0x4000) == 0x4000)
			inputbutton14.setImageResource(drawable.image100);
		else
			inputbutton14.setImageResource(drawable.image1);
		
		if ((cmddata & 0x8000) == 0x8000 )
			inputbutton15.setImageResource(drawable.image100);
		else
			inputbutton15.setImageResource(drawable.image1);
	}
}
