package com.PWMDemo;

import com.PWMDemo.R.drawable;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.SeekBar;
import android.widget.TextView;
import android.widget.Spinner;

public class PWMDemoActivity extends Activity {
	
	/*declare a CH9343 PWM interface variable*/
    public WCHPWMInterface pwmInterface;
    /*graphical objects*/
    EditText dutyCycle0Value;
    EditText dutyCycle1Value;
    EditText dutyCycle2Value;
    EditText dutyCycle3Value;
    
    Spinner periodSpinner;
    
    SeekBar seekbar0;
    SeekBar seekbar1;
    SeekBar seekbar2;
    SeekBar	seekbar3;
    
    Button periodButton;
    Button cycleButton;
    Button resetButton;
    
    
    int period;
    byte dutyCycle;
    byte dutyCycle1;
    byte periodspinnerMode; 
	
    private Handler mHandler = new Handler();
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);        
        
        /*create the objects*/
        dutyCycle0Value = (EditText)findViewById(R.id.DutyCycle0Value);
        dutyCycle1Value = (EditText)findViewById(R.id.DutyCycle1Value);
       
        seekbar0 = (SeekBar)findViewById(R.id.Channel0Seekbar);
        seekbar1 = (SeekBar)findViewById(R.id.Channel1Seekbar);
       
        
        periodButton = (Button)findViewById(R.id.PeriodButton);
        cycleButton = (Button)findViewById(R.id.CycleButton);
        resetButton = (Button)findViewById(R.id.resetButton);
        
        periodspinnerMode = 0;
        
        periodSpinner = (Spinner)findViewById(R.id.PeriodValue);
        ArrayAdapter<CharSequence> periodAdapter = ArrayAdapter.createFromResource(this, R.array.period_phase,
        																	android.R.layout.simple_spinner_item);
        
        periodSpinner.setAdapter(periodAdapter);
        periodSpinner.setSelection(0);//end
        
        
        pwmInterface = new WCHPWMInterface(this);
        resetCH9343();
        
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);

        resetButton.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				resetCH9343();
			}
		});
        

        periodButton.setOnClickListener(new View.OnClickListener() {
			// @Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				
				periodspinnerMode = (byte)periodSpinner.getSelectedItemPosition();
				
				pwmInterface.SetPeriod(periodspinnerMode);
			}
		});
        
        cycleButton.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				if(dutyCycle == 0x00 || dutyCycle1 == 0x00) {
					pwmInterface.SetDutyCycle(true, dutyCycle, dutyCycle1);
				} else if(dutyCycle != 0x00 && dutyCycle1 != 0x00) {
					pwmInterface.SetDutyCycle(true, dutyCycle, dutyCycle1);
				}
				
			}
		});
        
        /*take the valus of channel 0*/
        seekbar0.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
			
			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				
			}
			
			public void onStartTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				
			}
			
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				// TODO Auto-generated method stub
				dutyCycle = (byte)progress;
				dutyCycle0Value.setText(Integer.toString(progress));
				
				
			}
		});
        
        seekbar1.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
			
			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				// TODO Auto-generated method stub
				dutyCycle1 = (byte)progress;
				dutyCycle1Value.setText(Integer.toString(progress));
				
			}
		});
        
    }
    
    protected void resetCH9343()
    {	
		seekbar0.setProgress(0);
		
		periodSpinner.setSelection(0);
		pwmInterface.Reset();
    }
    
    @Override
    protected void onResume() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onResume();
        pwmInterface.ResumeAccessory();
    }

    @Override
    protected void onPause() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onPause();
        
       
  
    }
    
    @Override 
    protected void onDestroy(){
    	pwmInterface.DestroyAccessory();
    	super.onDestroy();
    }
    
}