package com.SPIMasterDemo;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

import com.SPIMasterDemo.R.drawable;

public class SPIMasterDemoActivity extends Activity {
	/*declare a CH9343 SPIMaster interface variable*/
    public WCHSPIMasterInterface spimInterface;
    /*graphical objects*/
    EditText readText;
    EditText writeText;
    EditText deviceAddressText,writeDeviceAddressText;
    EditText addressText,writeAddressText;
    EditText numBytesText;
    EditText statusText,writeStatusText;
    
    Button readButton, writeButton;
    Button configButton, resetButton;
    
    Spinner clockPhaseSpinner;
    Spinner dataOrderSpinner;
    Spinner frequencySpinner;
    
    /*local variables*/
    byte[] readWriteBuffer;
    byte [] numReadWritten;
        
    byte numBytes;
    byte count;
    byte status;
    byte clockPhaseMode;
    byte dataOrderSelected;
    byte frequencySelected;
    int clockFreq;
    
    
    /*parse the input values seperated by comma*/
    byte byteCount = 0;
	byte tempCount = 0;
	byte tempByte;
	byte [] tempBytes;
	String tempString;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        /*create editable text objects*/
         
        readText = (EditText)findViewById(R.id.ReadValues);
        readText.setInputType(0);
        writeText = (EditText)findViewById(R.id.WriteValues);
      
               
        numBytesText = (EditText)findViewById(R.id.NumberOfBytesValue);
        
       
        statusText=(EditText)findViewById(R.id.StatusValues);
        statusText.setInputType(0);
        writeStatusText = (EditText)findViewById(R.id.WriteStatusValues);
        writeStatusText.setInputType(0);
         
        readButton = (Button)findViewById(R.id.ReadButton);
        writeButton = (Button)findViewById(R.id.WriteButton);
        configButton = (Button)findViewById(R.id.ConfigButton);
        resetButton = (Button)findViewById(R.id.resetButton);
        
        
        /*allocate buffer*/
        readWriteBuffer = new byte[255];
        numReadWritten = new byte[1];
        tempBytes = new byte[3]; /*a byte can not be more than 3 digits, max 255*/
        /*default mode is set to mode 1*/
        clockPhaseMode = 1;
       
        
        clockPhaseSpinner = (Spinner)findViewById(R.id.ClockPhaseValue);
        ArrayAdapter<CharSequence> clockPhaseAdapter = ArrayAdapter.createFromResource(this,R.array.clock_phase, 
        																	android.R.layout.simple_spinner_item);
        
        clockPhaseSpinner.setAdapter(clockPhaseAdapter);
        clockPhaseSpinner.setSelection(1);
        
        
        /*data order*/
        /*default data order is set to MSB*/
        dataOrderSelected = 0;
        dataOrderSpinner = (Spinner)findViewById(R.id.DataOrderValue);
        ArrayAdapter<CharSequence> dataOrderAdapter = ArrayAdapter.createFromResource(this,R.array.data_order, 
        																	android.R.layout.simple_spinner_item);
        
        dataOrderSpinner.setAdapter(dataOrderAdapter);
        dataOrderSpinner.setSelection(dataOrderSelected);
        
        //frequencySpinner
        //default data order is set to 
        frequencySelected = 2;
        frequencySpinner = (Spinner)findViewById(R.id.ClockFreqValue);
        ArrayAdapter<CharSequence> frequencyAdapter = ArrayAdapter.createFromResource(this,R.array.frequency_phase,
        																	android.R.layout.simple_spinner_item);
        
        frequencySpinner.setAdapter(frequencyAdapter);
        frequencySpinner.setSelection(frequencySelected);
        
        spimInterface = new WCHSPIMasterInterface(this);
        
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
        
        
        resetButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) {
				//resetButton.setBackgroundResource(drawable.start);
				// TODO Auto-generated method stub
				/*clear the receive and send edit boxes*/
				readText.setText("");
				writeText.setText("");
				numBytesText.setText("");
				statusText.setText("");
				writeStatusText.setText("");				
				clockPhaseSpinner.setSelection(1); //mode 3
				dataOrderSpinner.setSelection(0); // select MSB
				frequencySpinner.setSelection(2); // select 3MHz

				spimInterface.Reset();
				
			}
		});
                
        readButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				//readButton.setBackgroundResource(drawable.start);
				numReadWritten[0] = 0x00;
				
				int numBytes_int = 0;
				int tmp_int = 0;
				
				if(numBytesText.length() != 0)
				{
				
					numBytes_int = Integer.parseInt(numBytesText.getText().toString());
				
					if( numBytes_int > 0xff )
					{
						numBytes_int = 0xff;
					}
					else
					{
						numBytes_int = Integer.parseInt(numBytesText.getText().toString());
					}
				
					for(int count_int=0;count_int < numBytes_int;count_int++){
						readWriteBuffer[count_int]=(byte)0xff;
					}
				
					status = spimInterface.ReadData(numBytes_int, readWriteBuffer, numReadWritten);
					/*read the bytes from the text box*/
					
					char [] displayReadbuffer;
					displayReadbuffer = new char[255];
					int displayActualNumBytes;
					displayActualNumBytes = (int)(numReadWritten[0] & 0xff);

					for(int count_int = 0;count_int < (displayActualNumBytes); count_int++){
						displayReadbuffer[count_int] = (char)readWriteBuffer[count_int];
					}
					readText.append(String.copyValueOf(displayReadbuffer, 0, displayActualNumBytes));
				}	
				
				tmp_int = (int)(numReadWritten[0] & 0xff);
				statusText.setText(Integer.toString(tmp_int));
			}
		});
        
        /*handle write click*/ // It's right
		writeButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) 
			{
				// TODO Auto-generated method stub
				//writeButton.setBackgroundResource(drawable.start);
				
				numReadWritten[0] = 0x00;
				
				/*parse the string*/
				byteCount = 0;
				tempCount = 0;
				
				int byteCount_int = 0;
				int numBytes_int = 0;
				int [] numReadWritten_int = new int [0];
				int tmp_int = 0;
				
				/*read the bytes from the write box*/
				if(writeText.length() != 0)
				{
				
					numBytes_int = writeText.length();
					
					if( numBytes_int > 0xff ) //Judge Max package length, 255
					{
						byteCount_int = 0xff;
					}
					else 
					{
						byteCount_int = writeText.length();			
					}
					for(int count_int=0; count_int < byteCount_int; count_int++){
						readWriteBuffer[count_int] = (byte)writeText.getText().charAt(count_int);
					}
					
					/*send only when there is something to be send*/
					if(byteCount_int != 0x00)
						status = spimInterface.SendData((byteCount_int), 
								readWriteBuffer, numReadWritten);
				}	
					tmp_int = (int)(numReadWritten[0] & 0xff);
					writeStatusText.setText(Integer.toString(tmp_int));
					
			}
		});
        
       /*config section*/ 
        configButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) {
				
				clockPhaseMode = (byte)clockPhaseSpinner.getSelectedItemPosition();
				dataOrderSelected = (byte)dataOrderSpinner.getSelectedItemPosition();
				frequencySelected = (byte)frequencySpinner.getSelectedItemPosition();
				
				spimInterface.SetConfig(clockPhaseMode, dataOrderSelected, frequencySelected);
			}
		});
    }

    @Override
    protected void onResume() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onResume();
        spimInterface.ResumeAccessory();
    }

    @Override
    protected void onPause() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onPause();
    }
    
    @Override 
    protected void onDestroy(){
    	
    	spimInterface.DestroyAccessory();
    	super.onDestroy();
    }

}