package com.SPISlaveDemo;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;

import com.SPISlaveDemo.R.drawable;


public class SPISlaveDemoActivity extends Activity {
	
	public handler_thread handlerThread;
	/*declare a CH9343 SPISlave interface variable*/
    public WCHSPISlaveInterface spisInterface;
    /*graphical objects*/
    EditText readText;
    EditText writeText;
    EditText addressText,writeAddressText;
    EditText numBytesText;
    EditText statusText,writeStatusText;
   
    
    Button readButton, writeButton;
    Button configButton, resetButton;
    
    Spinner clockPhaseSpinner;
    Spinner dataOrderSpinner;
    
    
    /*local variables*/
    //char[] readBuffer;
    byte [] readBuffer;
    byte [] numReadWritten_write;
    byte [] numReadWritten_read;
        
    byte numBytes;
    byte count;
    byte status;
    byte clockPhaseMode;
    byte dataOrderSelected;
    int clockFreq;
    
    
    /*parse the input values seperated by comma*/
    byte byteCount = 0;
	byte tempCount = 0;
	byte tempByte;
	byte [] tempBytes;
	String tempString;
    
   
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        /*create editable text objects*/
        readText = (EditText)findViewById(R.id.ReadValues);
        readText.setInputType(0);
        writeText = (EditText)findViewById(R.id.WriteValues);
      
         
        
        writeStatusText = (EditText)findViewById(R.id.WriteStatusValues);
        writeStatusText.setInputType(0);
       
         
        readButton = (Button)findViewById(R.id.ReadButton);
        //readButton.setVisibility(4);
        writeButton = (Button)findViewById(R.id.WriteButton);
        configButton = (Button)findViewById(R.id.ConfigButton);
        resetButton = (Button)findViewById(R.id.resetButton);
        
        
        /*allocate buffer*/
        readBuffer = new byte[255];
        numReadWritten_write = new byte[1];
        numReadWritten_read  = new byte[1];
        
        tempBytes = new byte[3]; /*a byte can not be more than 3 digits, max 255*/
        /*default mode is set to mode 1*/
        clockPhaseMode = 1;
       
        
        clockPhaseSpinner = (Spinner)findViewById(R.id.ClockPhaseValue);
        ArrayAdapter<CharSequence> clockPhaseAdapter = ArrayAdapter.createFromResource(this,R.array.clock_phase, 
        																	android.R.layout.simple_spinner_item);
        
        clockPhaseSpinner.setAdapter(clockPhaseAdapter);
        clockPhaseSpinner.setSelection(1);
        
        
        /*default data order is set to MSB*/
        dataOrderSelected = 0;
       
        
        dataOrderSpinner = (Spinner)findViewById(R.id.DataOrderValue);
        ArrayAdapter<CharSequence> dataOrderAdapter = ArrayAdapter.createFromResource(this,R.array.data_order, 
        																	android.R.layout.simple_spinner_item);
        
        dataOrderSpinner.setAdapter(dataOrderAdapter);
        dataOrderSpinner.setSelection(dataOrderSelected);
        
        spisInterface = new WCHSPISlaveInterface(this);
        
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
        
        resetButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) {
				//resetButton.setBackgroundResource(drawable.start);
				// TODO Auto-generated method stub
				/*clear the receive and send edit boxes*/
				readText.setText("");
				writeText.setText("");
				writeStatusText.setText("");
				clockPhaseSpinner.setSelection(1);
				dataOrderSpinner.setSelection(0);
				spisInterface.Reset();
				
			}
		});       
        
        
        readButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				//readButton.setBackgroundResource(drawable.start);
				spisInterface.EndHandleThread();				
			}
		});
        
        
        /*handle write click*/
        writeButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) 
			{
				// TODO Auto-generated method stub
				//writeButton.setBackgroundResource(drawable.start);
				
				numReadWritten_write[0] = 0x00;
				
				/*parse the string*/
				int byteCount_int = 0;
				int tempCount_int = 0;
				
				/*read the bytes from the write box*/
				if(writeText.length() != 0)
				{
					byteCount_int = writeText.length();
					
					if( byteCount_int > 0xff )
					{
						byteCount_int = 0xff;
					}
					else
					{
						byteCount_int = writeText.length();
					}				
					for(int count_int=0; count_int < byteCount_int; count_int++){
						readBuffer[count_int] = (byte)writeText.getText().charAt(count_int);
					}
					
					/*send only when there is something to be send*/
					if(byteCount_int != 0)
						status = spisInterface.SendData(byteCount_int, readBuffer, numReadWritten_write);
				}	
					int tmp_int = (int)(byteCount_int & 0xff);
					writeStatusText.setText(Integer.toString(tmp_int));
					
			}
		});
        
        
       /*config section*/ 
        configButton.setOnClickListener(new View.OnClickListener() {
			
			//@Override
			public void onClick(View v) {
				
				//configButton.setBackgroundResource(drawable.start);
				clockPhaseMode = (byte)clockPhaseSpinner.getSelectedItemPosition();
				dataOrderSelected = (byte)dataOrderSpinner.getSelectedItemPosition();
				spisInterface.SetConfig(clockPhaseMode,dataOrderSelected);
			}
		});
        
        handlerThread = new handler_thread(handler);
        handlerThread.start();
        
 }
     
    @Override
    protected void onResume() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onResume();
        spisInterface.ResumeAccessory();
    }

    @Override
    protected void onPause() {
        // Ideally should implement onResume() and onPause()
        // to take appropriate action when the activity looses focus
        super.onPause();
        
       
  
    }
    
    @Override 
    protected void onDestroy(){
    	
    	spisInterface.DestroyAccessory();
    	super.onDestroy();
    }
    
    
	final Handler handler = new Handler() {
		@Override
		public void handleMessage(Message msg) {
			if (numReadWritten_read[0] != 0x00) {
				char [] displayReadbuffer;
				displayReadbuffer = new char[255];
				int displayActualNumBytes;
				displayActualNumBytes = (int)(numReadWritten_read[0] & 0xff);

				for(int count_int = 0;count_int < (displayActualNumBytes); count_int++){
					displayReadbuffer[count_int] = (char)readBuffer[count_int];
				}
				
				readText.append(String.copyValueOf(displayReadbuffer, 0,
						displayActualNumBytes));
			}
		}
	};
	
	
	/*usb input data handler*/
	private class handler_thread  extends Thread {
		Handler mHandler;
		/*constructor*/
		handler_thread(Handler h ){
			mHandler = h;
			
		}
		
		public void run()
		{
			
			while(true)
			{
				Message msg = mHandler.obtainMessage();
				try{	
					Thread.sleep(50);
				} catch(InterruptedException e){}
				
				numReadWritten_read[0] = 0x00;
				status = spisInterface.ReadData((byte)64, readBuffer, numReadWritten_read);
				
				if (status == 0x00) {
				    mHandler.sendMessage(msg);
				}
			}
		}
	}
    

}